﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win.FormattedLinkLabel;

namespace _92920
{
    public partial class Form1 : Form
    {
    

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            
            ultraCombo1.CreationFilter = new MyCreation() {  BackColorText = Color.FromArgb(90,250,90)};
            DataTable ComboData = new DataTable("ComboTable");
            ComboData.Columns.Add("id", typeof(int)).AutoIncrement = true;
            ComboData.Columns.Add("cities", typeof(string));

            ComboData.Rows.Add(null, "New York");
            ComboData.Rows.Add(null, "New Jersey");
            ComboData.Rows.Add(null, "New Alabama");
            ComboData.Rows.Add(null, "New Mexico");
            ComboData.Rows.Add(null, "New Zeland");
            ComboData.Rows.Add(null, "New Taipei");
            ComboData.Rows.Add(null, "Los Angeles");
            ComboData.Rows.Add(null, "Abu Dhabi");
            ComboData.Rows.Add(null, "Buenos Aires");

            ultraCombo1.DataSource = ComboData;
            ultraCombo1.DisplayMember = "cities";
            ultraCombo1.ValueMember = "cities";
            ultraCombo1.DisplayLayout.Bands[0].Columns["cities"].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.FormattedText;
            ultraCombo1.DisplayLayout.Bands[0].Columns["id"].Hidden = true;
        }



        private void ultraCombo1_TextChanged(object sender, EventArgs e)
        {

            if (!ultraCombo1.IsDroppedDown)
            {
                ultraCombo1.PerformAction(Infragistics.Win.UltraWinGrid.UltraComboAction.Dropdown);
                ultraCombo1.SelectionStart = ultraCombo1.Text != null ? ultraCombo1.Text.Length : 0;
            }
            string editText = ultraCombo1.Text;
            if (string.IsNullOrEmpty(editText))
            {
                ultraCombo1.Rows.ToList<UltraGridRow>().ForEach(delegate(UltraGridRow row) { row.Hidden = false; });
                MyCreation.SearchedWords = null;
                return;
            }
            ultraCombo1.BeginUpdate();
            
            string[] words = editText.Split(new char[] { ' ' });
            List<UltraGridRow> foundedrows = new List<UltraGridRow>();
            foreach (string word in words)
            {
                if (string.IsNullOrEmpty(word))
                    continue;
                List<UltraGridRow> rows = ultraCombo1.Rows.Where(row => row.Cells[ultraCombo1.DisplayMemberResolved].Text.ToLower().Contains(word.ToLower()) && !foundedrows.Contains(row)).ToList<UltraGridRow>();// && row.Hidden))
                foundedrows.AddRange(rows);
            }
            ultraCombo1.Rows.ToList<UltraGridRow>().ForEach(delegate(UltraGridRow row)
            {
                row.Hidden = !foundedrows.Contains(row);
            });
            
            MyCreation.SearchedWords = words;
            ultraCombo1.EndUpdate();
           
        }
    }
}
